import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Properties;

import lbi.utils.DBUtil;
import lbi.utils.IOUtil;


public class Deviation {

	public static void main(String[] args) throws IOException, SQLException {
//		 load proprierties
        Properties props = IOUtil.readProps("myJDBCdef.props");
// load drivers
        DBUtil.loadJDBC(props.getProperty("jdbcDriver"));
// connect to data source, using userName and userPWD
        String url = props.getProperty("jdbcURL");
        String user = props.getProperty("userName");
        String pwd = props.getProperty("userPWD");
        Connection con = DriverManager.getConnection(url, user, pwd);
        Statement stmt = con.createStatement();
//   	 retrieve table and column from properties
        
        HashMap<Integer, Double> timeid2sales = new HashMap<Integer, Double>();
		ResultSet rs = stmt.executeQuery("SELECT * FROM sales_fact");
		double total = 0;
		while(rs.next()) {
			int time_id = rs.getInt("time_id");
			double sales = rs.getDouble("store_sales");
			total += sales;
			Double value = timeid2sales.get(time_id);
			if(value == null) 
				timeid2sales.put(time_id, sales);
			else
				timeid2sales.replace(time_id, sales + value);
		}
		
		int ndays = timeid2sales.size();
		double avg = total/ndays;
		
		int []timeids = new int[ndays];
		int id = 0;
		for( int timeid : timeid2sales.keySet())
			timeids[id++] = timeid;
		Arrays.sort(timeids);
		
		double max_dev = -1;
		int best_timeid_min = 0;
		int best_timeid_max = 0;
		for(int timeid_min = 0; timeid_min < ndays; ++timeid_min) {
			double dev = 0;
			for(int timeid_max = timeid_min; timeid_max < ndays; ++timeid_max) {
				dev += timeid2sales.get( timeids[timeid_max] ) - avg;
				if(dev > max_dev) {
					max_dev = dev;
					best_timeid_min = timeids[timeid_min];
					best_timeid_max = timeids[timeid_max];
				}
			}			
		}
		System.out.println(best_timeid_min + " " + best_timeid_max + " " + max_dev);		

	}

}
