-- sql with analytics that solves ex. 1
with timeid2sales as
(
  select time_id, sum(store_sales) as sales
  from sales_fact
  group by time_id
),
timeid2avg as
(select time_id, sales, avg(sales) over () as avg_sales
from timeid2sales
),
timeid2dev as
(select time_id, sales-avg_sales as dev
from timeid2avg),
timeid2runningdev as
(select time_id, dev, sum(dev) over(order by time_id 
                                rows unbounded preceding ) as running_dev
from timeid2dev)
select top 1 r1.time_id as time_id_min,
       r2.time_id as time_id_max,
	   r2.running_dev - r1.running_dev + r1.dev as interval_dev
from timeid2runningdev r1, timeid2runningdev r2
where r1.time_id <= r2.time_id
order by r2.running_dev - r1.running_dev + r1.dev desc

